import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { Project, ProjectParam } from './model';

/**
 * 分页查询项目
 */
export async function pageProject(params: ProjectParam) {
  const res = await request.get<ApiResult<PageResult<Project>>>(
    '/oa/project/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询项目列表
 */
export async function listProject(params?: ProjectParam) {
  const res = await request.get<ApiResult<Project[]>>('/oa/project', {
    params
  });
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询项目
 */
export async function getProject(id: number) {
  const res = await request.get<ApiResult<Project>>('/oa/project/' + id);
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加项目
 */
export async function addProject(data: Project) {
  const res = await request.post<ApiResult<unknown>>('/oa/project', data);
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改项目
 */
export async function updateProject(data: Project) {
  const res = await request.put<ApiResult<unknown>>('/oa/project', data);
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除项目
 */
export async function removeProject(id?: number) {
  const res = await request.delete<ApiResult<unknown>>('/oa/project/' + id);
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除项目
 */
export async function removeBatchProject(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>('/oa/project/batch', {
    data
  });
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 检查IP是否存在
 */
export async function checkExistence(
  field: string,
  value: string,
  id?: number
) {
  const res = await request.get<ApiResult<unknown>>('/oa/project/existence', {
    params: { field, value, id }
  });
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
